#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n, q;
    cin>>n>>q;
    vector<long long> d(n+1);
    vector<int> p(n);
    d[n]=LONG_LONG_MAX;
    for(int i=0;i<n;i++)
    {
        cin>>d[i];
        cin>>p[i];
        d[i]--;
    }
    for(int i=0;i<q;i++)
    {
        long long k, u=0, o=0;
        cin>>k;
        int b=0;
        for(long long j=0;j<max(n,k);j++)
        {
            cout<<"j="<<j<<endl;
            if(b<n && d[b]==j)
            {
                u+=p[b];
                b++;
                cout<<"    ok1"<<endl;
            }
            if(u!=0)
            {
                o+=min(u,min(d[b],k)-j);
                u-=min(u,min(d[b],k)-j);
                j=min(d[b],k)-1;
                cout<<"    ok2  j="<<j<<endl;
            }
            cout<<"  u="<<u<<"  o="<<o<<"  b="<<b<<endl;
        }
        cout<<"konacan odgovor: "<<o<<endl;
    }
    return 0;
}